package sk.seges.sesam.core.test.selenium.configuration.annotation;

import java.io.PrintStream;

import javax.annotation.Generated;

import sk.seges.sesam.core.configuration.annotation.Settings;
import sk.seges.sesam.core.configuration.api.ConfigurationValue;
import sk.seges.sesam.core.configuration.utils.ConfigurationUtils;

@Settings(configuration = Credentials.class)
@Generated(value = "sk.seges.sesam.pap.configuration.processor.SettingsProcessor")
public class CredentialsSettings {

	private String password;

	private String username;

	/**
	* Password used to login to the system
	*/
	public String getPassword() {
		return password;
	}
	
	public void setPassword(String password) {
		this.password = password;
	}
	
	/**
	* Username used to login to the system
	*/
	public String getUsername() {
		return username;
	}
	
	public void setUsername(String username) {
		this.username = username;
	}
	
	public CredentialsSettings(ConfigurationValue[] configurations) {
		this.password = ConfigurationUtils.getConfigurationValue(configurations, "test.password");
		this.username = ConfigurationUtils.getConfigurationValue(configurations, "test.username");
	}

	public CredentialsSettings(String password, String username) {
		this.password = password;
		this.username = username;
	}

	public CredentialsSettings(CredentialsSettings credentialsSettings) {
		this.password = credentialsSettings.getPassword();
		this.username = credentialsSettings.getUsername();
	}

	public CredentialsSettings merge(CredentialsSettings credentialsSettings) {
		if (credentialsSettings == null) {
			return this;
		}
		if (password == null) {
			this.password = credentialsSettings.getPassword();
		}
		if (username == null) {
			this.username = credentialsSettings.getUsername();
		}
		return this;
	}

	public void printHelp(PrintStream out) {
		printHelp(out, "", null);
	}

	public void printHelp(PrintStream out, String prefix, String name) {
		out.format("%-50s Password used to login to the system" + (name != null ? " for " + name : "") + "\n", prefix + "test.password");
		out.format("%-50s Username used to login to the system" + (name != null ? " for " + name : "") + "\n", prefix + "test.username");
	}
}