package sk.seges.sesam.core.test.selenium.configuration.annotation;

import java.io.PrintStream;

import javax.annotation.Generated;

import sk.seges.sesam.core.configuration.annotation.Settings;
import sk.seges.sesam.core.configuration.api.ConfigurationValue;
import sk.seges.sesam.core.configuration.utils.ConfigurationUtils;
import sk.seges.sesam.core.test.selenium.configuration.annotation.Mail.Provider;

@Settings(configuration = Mail.class)
@Generated(value = "sk.seges.sesam.pap.configuration.processor.SettingsProcessor")
public class MailSettings {

	private String host;

	private String mail;

	private String password;

	private Provider provider;

	/**
	* E-mail host name
	*/
	public String getHost() {
		return host;
	}
	
	public void setHost(String host) {
		this.host = host;
	}
	
	/**
	* E-mail recepient settings
	*/
	public String getMail() {
		return mail;
	}
	
	public void setMail(String mail) {
		this.mail = mail;
	}
	
	/**
	* E-mail password settings
	*/
	public String getPassword() {
		return password;
	}
	
	public void setPassword(String password) {
		this.password = password;
	}
	
	/**
	* E-mail provider
	*/
	public Provider getProvider() {
		return provider;
	}
	
	public void setProvider(Provider provider) {
		this.provider = provider;
	}
	
	public MailSettings(ConfigurationValue[] configurations) {
		this.host = ConfigurationUtils.getConfigurationValue(configurations, "mail.host");
		this.mail = ConfigurationUtils.getConfigurationValue(configurations, "mail.address");
		this.password = ConfigurationUtils.getConfigurationValue(configurations, "mail.password");
		String _provider = ConfigurationUtils.getConfigurationValue(configurations, "mail.provider");
		for (Provider _enumValue: Provider.values()) {
			if (_enumValue.toString().equals(_provider)) {
				this.provider = _enumValue;
			}
		}
	}

	public MailSettings(String host, String mail, String password, Provider provider) {
		this.host = host;
		this.mail = mail;
		this.password = password;
		this.provider = provider;
	}

	public MailSettings(MailSettings mailSettings) {
		this.host = mailSettings.getHost();
		this.mail = mailSettings.getMail();
		this.password = mailSettings.getPassword();
		this.provider = mailSettings.getProvider();
	}

	public MailSettings merge(MailSettings mailSettings) {
		if (mailSettings == null) {
			return this;
		}
		if (host == null) {
			this.host = mailSettings.getHost();
		}
		if (mail == null) {
			this.mail = mailSettings.getMail();
		}
		if (password == null) {
			this.password = mailSettings.getPassword();
		}
		if (provider == null) {
			this.provider = mailSettings.getProvider();
		}
		return this;
	}

	public void printHelp(PrintStream out) {
		printHelp(out, "", null);
	}

	public void printHelp(PrintStream out, String prefix, String name) {
		out.format("%-50s E-mail host name" + (name != null ? " for " + name : "") + "\n", prefix + "mail.host");
		out.format("%-50s E-mail recepient settings" + (name != null ? " for " + name : "") + "\n", prefix + "mail.address");
		out.format("%-50s E-mail password settings" + (name != null ? " for " + name : "") + "\n", prefix + "mail.password");
		out.format("%-50s E-mail provider" + (name != null ? " for " + name : "") + "\n", prefix + "mail.provider");
		out.format("%-50s Possible values: " + Provider.IMAP.toString() + ","  + Provider.IMAPS.toString() + "\n", "");
	}
}